camera = {}
camera.__index = camera

function camera.new()
  return setmetatable({rotation = 0, 
    scaleX = 1,
    scaleY = 1,
    position = Vector.new(0,0)}, camera)
--[[camera.layers = {}
camera.scaleX = 1
camera.scaleY = 1
--]]
end

function camera:set()
  love.graphics.push()
  local mapx = self.position.x
  local mapy = self.position.y
  local isox = ((mapy/sqrt2)+(mapx/sqrt2)) * 105 
  local isoy = ((mapy/sqrt2)-(mapx/sqrt2)) * 60.2   + 1500

  love.graphics.scale(1 / self.scaleX, 1 / self.scaleY)
  love.graphics.translate(-isox +love.graphics.getWidth()/2, -isoy+love.graphics.getHeight()/2)
end

function camera:unset()
  love.graphics.pop()
end

function camera:move(dx, dy)
  self.position.x = self.position.x + (dx or 0)
  self.position.y = self.position.y + (dy or 0)
end

function camera:rotate(dr)
  self.rotation = self.rotation + dr
end


function camera:setPosition(x, y)
  self.position.x = x or self.position.x
  self.position.y = y or self.position.y
end

function camera:scale(sx, sy)
  sx = sx or 1
  self.scaleX = self.scaleX * sx
  self.scaleY = self.scaleY * (sy or sx)
end


function camera:setScale(sx, sy)
  self.scaleX = sx or self.scaleX
  self.scaleY = sy or self.scaleY
end


setmetatable(camera, { __call = function(_, ...) return camera.new(...) end })
