container = {}
container.__index = container

function container.new(myPosition, myVelocity, mySpeed, myStatic, myImage)
	return setmetatable({position = myPosition,
		drawOrder = 0,
		velocity = myVelocity,
		speed = mySpeed,
		isStatic = myStatic,
		imageName = myImage,
		image = love.graphics.newImage(myImage)}, container)
end


function container:draw(x,y)
	love.graphics.draw(self.image,x-self.image:getWidth()/2,y-self.image:getHeight()/2)
end

--updates any animations and the conatiner's x and y
function container:update(dt)

end

function container:getDrawOrder()
	return self.drawOrder
end

function container:getSpeed()
	return self.speed
end


function container:getVelocity()
	return self.velocity
end

function container:getPosition()
	return self.position
end

function container:getImage()
	return self.image
end

function container:getX()
	return self.position.x 
end

function container:getY()
	return self.position.y
end

function container:getStatic()
	return self.isStatic
end

function container:setDrawOrder(x)
	self.drawOrder = x
end

function container:setVelocity(vector)
	self.velocity = vector
end

function container:setPosition(vector)
	self.position = vector
end


function container:setX(x)
	self.position.x = x
end

function container:setY(y)
	self.position.y = y
end



function container:printInfo()
	print(self.position.x)
	print(self.position.y)
	print(self.imageName)
end

setmetatable(container, { __call = function(_, ...) return container.new(...) end })