mainCharacter = {}
mainCharacter.__index = mainCharacter

function mainCharacter.new(x,y)
	camera:move(x,y)

	return setmetatable({object = object.new("mainCharacter", "PC", true, container.new(Vector.new(x,y),Vector.new(0,0),.5,false,"Images/testimage.png")),
		destination = Vector.new(x,y)}, mainCharacter)
end


function mainCharacter:draw(x,y)
	local image = self:getImage()
	local height = image:getHeight()
	local width = image:getWidth()
	love.graphics.draw(image, x - width/2 , y - height/2)
end


function mainCharacter:update(dt)

	local distanceTraveled = Vector.new(0,0)
	if love.mouse.isDown("l") then 

		local mapx,mapy  = self:convertToMap(love.mouse.getX() - love.graphics.getWidth()/2,love.mouse.getY()-love.graphics.getHeight()/2)


        self.destination = Vector.new(mapx,mapy)

        self:setVelocity((self.destination - self:getPosition()):normalize())

        
        --If the object is within .05 units of it's destination it will stop
        if (self.destination.x - .05 > self:getX() or  self:getX() > self.destination.x + .05) or 
            (self.destination.y - .05 > self:getY() or self:getY() > self.destination.y + .05) then

            distanceTraveled = self:getVelocity() * self:getSpeed()
            self:setPosition(self:getPosition() + distanceTraveled)
            camera:move(distanceTraveled.x,distanceTraveled.y)
        else
            self.velocity = Vector.new(0,0)
            self.mydestination = self:getPosition()
        end
    else
    	self:setVelocity((self.destination - self:getPosition()):normalize())
    	--If the object is within .05 units of it's destination it will stop
    	if (self.destination.x - .05 > self:getX() or  self:getX() > self.destination.x + .05) or 
            (self.destination.y - .05 > self:getY() or self:getY() > self.destination.y + .05) then

            distanceTraveled = self:getVelocity() * self:getSpeed()
            self:setPosition(self:getPosition() + distanceTraveled)
            camera:move(distanceTraveled.x,distanceTraveled.y)
        else
            self:setVelocity(Vector.new(0,0))
            self.destination = self:getPosition()
        end
    end
   
end



function mainCharacter:convertToMap(screenx,screeny)
	local posx = self:getX()
	local posy = self:getY()

	local isox = ((posy/sqrt2)+(posx/sqrt2)) * 105
	local isoy = ((posy/sqrt2)-(posx/sqrt2)) * 60.2   + 1500

	local isoDestinationX = isox + screenx
	local isoDestinationY = isoy + screeny
	
	local mapx = ((isoDestinationX/105)/sqrt2 - ((isoDestinationY-1500)/60.2)/sqrt2)
	local mapy = (((isoDestinationY-1500)/60.2)/sqrt2 + ((isoDestinationX/105)/sqrt2)) 



	return mapx, mapy

end



function mainCharacter:getName()
	return self.object:getName()
end

function mainCharacter:getVelocity()
	return self.object:getVelocity()
end

function mainCharacter:getPosition()
	return self.object:getPosition()
end

function mainCharacter:getImage()
	return self.object:getImage()
end

function mainCharacter:getX()
	return self.object:getX()
end

function mainCharacter:getY()
	return self.object:getY()
end

function mainCharacter:getDestination()
	return self.destination
end

function mainCharacter:getSpeed()
	return self.object:getSpeed()
end

function mainCharacter:getStatic()
	return false
end

function mainCharacter:setDestination(vector)
	self.destination = vector
end

function mainCharacter:setVelocity(vector)
	self.object:setVelocity(vector)
end

function mainCharacter:setPosition(vector)
	self.object:setPosition(vector)

end

function mainCharacter:setX(x)
	self.object:setX(x)
	camera:move(x,0)
end

function mainCharacter:setY(y)
	self.object:setY(y)
	camera:move(0,y)
end

function mainCharacter:printInfo()
	self.object:printInfo()
end

setmetatable(mainCharacter, { __call = function(_, ...) return mainCharacter.new(...) end })