object = {}
object.__index = object


function object.new(myName, objectType, myInventory, myContainer)
	return setmetatable({name = myName,
		objectType = mytype,
		hasInventory = myInventory,
		container = myContainer or nil}, object)
end

function object:update(dt)
	if self.container then
		self.container:update(dt)
	end
end

function object:draw(x,y)
	if self.container then
		self.container:draw(x,y)
	else
	end
end

function object:getImage()
	if self.container then
		return self.container:getImage()
	else
	end
end

function object:getVelocity()
	if self.container then
		return self.container:getVelocity()
	else
	end
end

function object:getSpeed()
	if self.container then
		return self.container:getSpeed()
	else
	end
end

function object:getPosition()
	if self.container then
		return self.container:getPosition()
	else
	end
end

function object:getX()
	if self.container then
		return self.container:getX()
	else
	end
end

function object:getY()
	if self.container then
		return self.container:getY()
	else
	end
end

function object:getName()
	return self.name
end

function object:setVelocity(vector)
	if self.container then
		self.container:setVelocity(vector)
	else
	end
end

function object:setPosition(vector)
	if self.container then
		self.container:setPosition(vector)
	else
	end
end

function object:setX(x)
	if self.container then
		self.container:setX(x)
	else
	end
end

function object:setY(y)
	if self.container then
		self.container:setY(y)
	else
	end
end

function object:getStatic()
	return self.container:getStatic()
end

function object:printInfo()
	if self.container then
		self.container:printInfo()
	else
	end
end


setmetatable(object, { __call = function(_, ...) return object.new(...) end })